SET LOCK_MODE 3;
CREATE USER IF NOT EXISTS SA SALT 'b1172c2894c69660' HASH 'bff055ba7d45c00dec0b614602a5e61d1ce9c8335117ebdd5b3fa67ca1fcb123' ADMIN;
CREATE SEQUENCE PUBLIC.HIBERNATE_SEQUENCE START WITH 1542;

CREATE CACHED TABLE PUBLIC.BUILDING(
    ID BIGINT NOT NULL,
    NAME VARCHAR(40) NOT NULL,
    VERSION INTEGER NOT NULL,
    MAINROOMID BIGINT
);
ALTER TABLE PUBLIC.BUILDING ADD CONSTRAINT PUBLIC.CONSTRAINT_D PRIMARY KEY(ID);

CREATE CACHED TABLE PUBLIC.CLASSIFICATION(
    ID INTEGER NOT NULL,
    LABEL VARCHAR(255),
    VERSION INTEGER NOT NULL,
    PARENTID INTEGER
);
ALTER TABLE PUBLIC.CLASSIFICATION ADD CONSTRAINT PUBLIC.CONSTRAINT_3 PRIMARY KEY(ID);

CREATE CACHED TABLE PUBLIC.DATESEXAMPLE(
    ID BIGINT NOT NULL,
    ADATE DATE,
    ADATEMIDNIGHT DATE,
    ADATEMIDNIGHTTZ VARCHAR(255),
    ADATEMIDNIGHTWITHTZ DATE,
    ADATETIME TIMESTAMP,
    ADATETIMETZ VARCHAR(255),
    ADATETIMEWITHTZ TIMESTAMP,
    ALOCALDATE DATE,
    ALOCALDATETIME TIMESTAMP,
    ALOCALTIMEASMILLIS INTEGER,
    ALOCALTIMEASSTRING VARCHAR(255),
    ALOCALTIMEASTIME TIME,
    ATIME TIME,
    ATIMESTAMP TIMESTAMP,
    VERSION INTEGER NOT NULL
);
ALTER TABLE PUBLIC.DATESEXAMPLE ADD CONSTRAINT PUBLIC.CONSTRAINT_9 PRIMARY KEY(ID);

CREATE CACHED TABLE PUBLIC.DEPARTMENT(
    ID BIGINT NOT NULL,
    NAME VARCHAR(40) NOT NULL,
    VERSION INTEGER NOT NULL
);
ALTER TABLE PUBLIC.DEPARTMENT ADD CONSTRAINT PUBLIC.CONSTRAINT_4 PRIMARY KEY(ID);

CREATE CACHED TABLE PUBLIC.PERSON(
    ID BIGINT NOT NULL,
    FIRSTNAME VARCHAR(10) NOT NULL,
    LASTNAME VARCHAR(10) NOT NULL,
    REGION VARCHAR(255),
    STARTDATE DATE,
    VERSION INTEGER NOT NULL
);
ALTER TABLE PUBLIC.PERSON ADD CONSTRAINT PUBLIC.CONSTRAINT_8 PRIMARY KEY(ID);

CREATE CACHED TABLE PUBLIC.ROLE(
    ID BIGINT NOT NULL,
    NAME VARCHAR(20),
    VERSION INTEGER NOT NULL
);
ALTER TABLE PUBLIC.ROLE ADD CONSTRAINT PUBLIC.CONSTRAINT_2 PRIMARY KEY(ID);

CREATE CACHED TABLE PUBLIC.ROOM(
    ID BIGINT NOT NULL,
    NAME VARCHAR(20) NOT NULL,
    VERSION INTEGER NOT NULL,
    BUILDINGID BIGINT NOT NULL
);
ALTER TABLE PUBLIC.ROOM ADD CONSTRAINT PUBLIC.CONSTRAINT_267 PRIMARY KEY(ID);

CREATE CACHED TABLE PUBLIC.STRINGTHING(
    ID VARCHAR(3) NOT NULL,
    NAME VARCHAR(20) NOT NULL,
    VERSION INTEGER NOT NULL
);
ALTER TABLE PUBLIC.STRINGTHING ADD CONSTRAINT PUBLIC.CONSTRAINT_27 PRIMARY KEY(ID);

CREATE CACHED TABLE PUBLIC.STUDENT(
    ID BIGINT NOT NULL,
    NAME VARCHAR(20) NOT NULL,
    VERSION INTEGER NOT NULL,
    TEACHERID BIGINT NOT NULL
);
ALTER TABLE PUBLIC.STUDENT ADD CONSTRAINT PUBLIC.CONSTRAINT_B PRIMARY KEY(ID);

CREATE CACHED TABLE PUBLIC.TEACHER(
    ID BIGINT NOT NULL,
    NAME VARCHAR(20) NOT NULL,
    VERSION INTEGER NOT NULL,
    DEPARTMENTID BIGINT,
    FAVOURITEROOMID BIGINT
);
ALTER TABLE PUBLIC.TEACHER ADD CONSTRAINT PUBLIC.CONSTRAINT_D4 PRIMARY KEY(ID);

CREATE CACHED TABLE PUBLIC.USERPASSWORD(
    ID BIGINT NOT NULL,
    PASSWORD VARCHAR(32),
    VERSION INTEGER NOT NULL
);
ALTER TABLE PUBLIC.USERPASSWORD ADD CONSTRAINT PUBLIC.CONSTRAINT_A PRIMARY KEY(ID);

CREATE CACHED TABLE PUBLIC.USERROLE(
    ID BIGINT NOT NULL,
    ACTIVE BOOLEAN NOT NULL,
    VERSION INTEGER NOT NULL,
    ROLEID BIGINT NOT NULL,
    USERID BIGINT NOT NULL
);
ALTER TABLE PUBLIC.USERROLE ADD CONSTRAINT PUBLIC.CONSTRAINT_1 PRIMARY KEY(ID);

CREATE CACHED TABLE PUBLIC.USERS(
    ID BIGINT NOT NULL,
    ACTIVE BOOLEAN NOT NULL,
    DATEINPUTPATTERN VARCHAR(20) NOT NULL,
    DATELISTPATTERN VARCHAR(20) NOT NULL,
    DATEVIEWPATTERN VARCHAR(20) NOT NULL,
    EMAILADDRESS VARCHAR(80),
    EXPIRYDATE DATE,
    FIRSTNAME VARCHAR(20) NOT NULL,
    LASTNAME VARCHAR(20) NOT NULL,
    LOGINID VARCHAR(15) NOT NULL,
    PAGESTYLE INTEGER,
    SALUTATION VARCHAR(6),
    VERSION INTEGER NOT NULL,
    USERPASSWORDID BIGINT
);
ALTER TABLE PUBLIC.USERS ADD CONSTRAINT PUBLIC.CONSTRAINT_4D PRIMARY KEY(ID);

ALTER TABLE PUBLIC.USERS ADD CONSTRAINT PUBLIC.CONSTRAINT_4D4 UNIQUE(LOGINID);
ALTER TABLE PUBLIC.ROLE ADD CONSTRAINT PUBLIC.CONSTRAINT_26 UNIQUE(NAME);
ALTER TABLE PUBLIC.DEPARTMENT ADD CONSTRAINT PUBLIC.CONSTRAINT_4F UNIQUE(NAME);
ALTER TABLE PUBLIC.USERROLE ADD CONSTRAINT PUBLIC.CONSTRAINT_1E UNIQUE(USERID, ROLEID);
ALTER TABLE PUBLIC.CLASSIFICATION ADD CONSTRAINT PUBLIC.FK6DD211ED23225B2 FOREIGN KEY(PARENTID) REFERENCES PUBLIC.CLASSIFICATION(ID) NOCHECK;
ALTER TABLE PUBLIC.USERS ADD CONSTRAINT PUBLIC.FK4E39DE8E8287ADF FOREIGN KEY(USERPASSWORDID) REFERENCES PUBLIC.USERPASSWORD(ID) NOCHECK;
ALTER TABLE PUBLIC.ROOM ADD CONSTRAINT PUBLIC.FK26F4FBCD3DDF4A FOREIGN KEY(BUILDINGID) REFERENCES PUBLIC.BUILDING(ID) NOCHECK;
ALTER TABLE PUBLIC.TEACHER ADD CONSTRAINT PUBLIC.FKD6A63C2C5E13B46 FOREIGN KEY(DEPARTMENTID) REFERENCES PUBLIC.DEPARTMENT(ID) NOCHECK;
ALTER TABLE PUBLIC.STUDENT ADD CONSTRAINT PUBLIC.FKF3371A1BD330D5B8 FOREIGN KEY(TEACHERID) REFERENCES PUBLIC.TEACHER(ID) NOCHECK;
ALTER TABLE PUBLIC.USERROLE ADD CONSTRAINT PUBLIC.FKF3F76701A04A94DF FOREIGN KEY(ROLEID) REFERENCES PUBLIC.ROLE(ID) NOCHECK;
ALTER TABLE PUBLIC.USERROLE ADD CONSTRAINT PUBLIC.FKF3F76701A59FEA49 FOREIGN KEY(USERID) REFERENCES PUBLIC.USERS(ID) NOCHECK;
ALTER TABLE PUBLIC.BUILDING ADD CONSTRAINT PUBLIC.FKAE9476D4F2EFE051 FOREIGN KEY(MAINROOMID) REFERENCES PUBLIC.ROOM(ID) NOCHECK;
ALTER TABLE PUBLIC.TEACHER ADD CONSTRAINT PUBLIC.FKD6A63C2AA7E8741 FOREIGN KEY(FAVOURITEROOMID) REFERENCES PUBLIC.ROOM(ID) NOCHECK;
